﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace DataGridView_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Set AutoGenerateColumns False.
            dataGridView1.AutoGenerateColumns = false;

            //Set Columns Count. 
            dataGridView1.ColumnCount = 4;

            //Add Columns.
            dataGridView1.Columns[0].Name = "SerialNo";
            dataGridView1.Columns[0].HeaderText = "Serial No.";
            dataGridView1.Columns[0].DataPropertyName = "SerialNo";

            dataGridView1.Columns[1].Name = "CustomerId";
            dataGridView1.Columns[1].HeaderText = "Customer Id";
            dataGridView1.Columns[1].DataPropertyName = "CustomerID";

            dataGridView1.Columns[2].HeaderText = "Contact Name";
            dataGridView1.Columns[2].Name = "ContactName";
            dataGridView1.Columns[2].DataPropertyName = "ContactName";

            dataGridView1.Columns[3].Name = "Country";
            dataGridView1.Columns[3].HeaderText = "Country";
            dataGridView1.Columns[3].DataPropertyName = "Country";
            dataGridView1.DataSource = GetData("SELECT CustomerID, ContactName, Country FROM Customers");
        }

        private static DataTable GetData(string query)
        {
            DataTable dt = new DataTable();
            string constr = @"Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123";
            using (SqlConnection con = new SqlConnection(constr))
            {
                using (SqlCommand cmd = new SqlCommand(query, con))
                {
                    cmd.CommandType = CommandType.Text;
                    con.Open();
                    using (SqlDataReader sdr = cmd.ExecuteReader())
                    {
                        //Add columns to DataTable.
                        dt.Columns.AddRange(new DataColumn[4] { 
                        new DataColumn("SerialNo"), 
                        new DataColumn("CustomerID"), 
                        new DataColumn("ContactName"), 
                        new DataColumn("Country") 
                });

                        //Set AutoIncrement True for the First Column.
                        dt.Columns["SerialNo"].AutoIncrement = true;

                        //Set the Starting or Seed value.
                        dt.Columns["SerialNo"].AutoIncrementSeed = 1;

                        //Set the Increment value.
                        dt.Columns["SerialNo"].AutoIncrementStep = 1;
                        while (sdr.Read())
                        {
                            dt.Rows.Add(null, sdr["CustomerID"], sdr["ContactName"], sdr["Country"]);
                        }
                    }
                    con.Close();
                }
            }

            return dt;
        }
    }
}
